<?php
/**
 * @package     ContentBuilder
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

if(!class_exists('CBFormElementAfterValidation') && !JFile::exists(JPATH_SITE . DS . 'administrator' . DS . 'components' . DS . 'com_contentbuilder' . DS . 'classes' . DS . 'contentbuilder_classes.php'))
{
    class CBFormElementAfterValidation{}
}
else if(!class_exists('CBFormElementAfterValidation'))
{
    require_once(JPATH_SITE . DS . 'administrator' . DS . 'components' . DS . 'com_contentbuilder' . DS . 'classes' . DS . 'contentbuilder_classes.php');
}
/**
 * If this class is used then BOTH methods need to be defined, wether if only one is used!
 */
class CBCountryListAfter extends CBFormElementAfterValidation{
    
    private $field = null;
    private $form = null;
    private $catid = 0;
    
    function __construct($form, $field, $catid) {
        $this->form = $form;
        $this->catid = $catid;
        $this->field = $field;
    }
    
    function onSaveRecord($record_id){
        
    }
    
    function onSaveArticle($article_id){
        
        
    }
}


class plgContentbuilder_form_elementsCountry_list extends JPlugin
{
        function __construct( &$subject, $params )
        {
            parent::__construct($subject, $params);
        
            $lang = JFactory::getLanguage();
            $lang->load('plg_contentbuilder_form_elements_country_list', JPATH_ADMINISTRATOR);
        }
        
        /**
         * Displays settings in the form element options window
         * 
         * The members of the $options stdClass should be defaulted before doing anything as they might not exist yet!
         * 
         * @param stdClass $options
         * @return array associative with indices 'element_type' (string), 'has_hint' (boolean), 'show_init_code_settings' (boolean), 'show_validation_settings' (boolean), 'settings' (string)
         */
        function onSettingsDisplay($options){
            
            $countries_included = isset($options->countries_included) ? $options->countries_included : array();
            $length = isset($options->length) ? $options->length : '';
            
            $settings = array();
            $settings['element_type'] = JText::_('COM_CONTENTBUILDER_TYPE_COUNRTRY_LIST');
            $settings['has_hint'] = true;
            $settings['show_init_code_settings'] = true;
            $settings['show_validation_settings'] = true;
            
            $settings['settings'] = '<table class="admintable" width="100%"><tr><td width="100" align="left" class="key">';
            $settings['settings'] .= '<label for="countrylist_included">'.JText::_('COM_CONTENTBUILDER_COUNTRY_LIST_INCLUDED').'</label></td><td align="left">';
            
            $lang_tag = JFactory::getLanguage()->getTag();
            $countries = $this->getCountries($lang_tag, 'countrylist_included[]', $countries_included, 'multiple="multiple"', 'width: 100%; height: 200px;');
            
            $settings['settings'] .= $countries;
            $settings['settings'] .= '</td></tr>';
            $settings['settings'] .= '<tr><td width="100" align="left" class="key">';
            $settings['settings'] .= '</td></tr>';
            
            $settings['settings'] .= '<tr>
                    <td width="100" align="left" class="key">
                        <label for="length">
                            '.JText::_( 'COM_CONTENTBUILDER_ELEMENT_OPTIONS_LENGTH' ).':
                        </label>
                    </td>
                    <td align="left">
                        <input style="width:100%;" type="text" name="length" id="length" value="'.$length.'"/>
                    </td>
               </tr>';
            
            $settings['settings'] .= '</table>';
            
            return $settings;
        }
        
        /**
         *
         * Handles the storage from onSettingsDisplay
         * 
         * @return type array with indices 'options' (stdClass), 'default_value' (string)
         */
        function onSettingsStore(){
            $options = new stdClass();
            $options->countries_included = JRequest::getVar('countrylist_included',array(),'','ARRAY');
            if(!count($options->countries_included)){
               JFactory::getApplication()->enqueueMessage(JText::_('COM_CONTENTBUILDER_COUNTRY_LIST_INCLUDE_ERROR'), 'error'); 
            }
            $options->length = JRequest::getVar('length','');
            return array('options' => $options, 'default_value' => '');
        }
        
        /**
         * Renders the elements in the form.
         * 
         * @param array $item
         * @param array $element
         * @param stdClass $options
         * @param array $failed_values
         * @param array $result
         * @param boolean $hasRecords
         * @return string 
         */
        function onRenderElement($item, $element, $options, $failed_values, $result, $hasRecords){
            
            if(!isset($options->countries_included)){
               $options->countries_included = array();
            }
            
            if(!isset($options->length)){
               $options->length = '';
            }
            
            $the_item = '<div class="">';
                               
            $lang_tag = JFactory::getLanguage()->getTag();
            $the_item .= $this->getCountries($lang_tag, 'cb_'.$item['id'].'[]', $item['value'], 'id="cb_'.$item['id'].'"', ($options->length ? 'width:'.$options->length.';' : ''), $options->countries_included);
            
            $the_item .= '</div>';
            
            $plugin = JPluginHelper::getPlugin('contentbuilder_form_elements', 'country_list');
            jimport( 'joomla.html.parameter' );
            $pluginParams = CBCompat::getParams($plugin->params);

            if($pluginParams->def('enable_geo', 1)){
            
                // geoplugin settings

                $the_item .= "
                <script type=\"text/javascript\">\n
                <!--\n
                var script = document.createElement('script');\n
                script.setAttribute('src', '".(strpos(strtolower(JURI::current()), 'https') !== false ? 'https://ssl.geoplugin.net/json.gp?jsoncallback=contentbuilder_country_list_geo' : 'http://www.geoplugin.net/json.gp?jsoncallback=contentbuilder_country_list_geo' )."');\n
                document.getElementsByTagName('head')[0].appendChild(script);\n
                //-->\n
                </script>\n";

                JFactory::getDocument()->addScriptDeclaration("
                \n
                <!--\n
                function contentbuilder_country_list_geo(result){\n
                    var code = result.geoplugin_countryCode;\n
                    var gelb = document.getElementById('cb_".$item['id']."');\n
                    if(gelb.selectedIndex <= 0){\n
                        for(var i = 0; i < gelb.options.length; i++){\n
                            if( ( typeof gelb.options[i].value.split(':')[1] != 'undefined' || gelb.options[i].value.split(':')[1] == '' ) && gelb.options[i].value.split(':')[1] == code ){\n
                                gelb.selectedIndex = i;\n
                                break;\n
                            }\n
                        }\n
                    }\n
                }\n
                //-->\n");
            
            }
            
            return $the_item;
        }
        
        /**
         * After submitting and the validation has been successfull, this can be used to take actions right after validation.
         * 
         * If you need to alter records/articles, you may pass an instance of the class "CBFormElementAfterValidation" as return value.
         * 
         * Once it will be returned, it MUST provide the methods onSaveRecord(int record_id) and onSaveArticle(int article_id), wether you use only one of them or both.
         * 
         * These methods will then be called after record/article creation/update.
         * 
         * @param array $field
         * @param array $fields
         * @param int $record_id
         * @param object $form
         * @param array $value
         * @return CBFormElementAfterValidation 
         */
        function onAfterValidationSuccess( $field, $fields, $record_id, $form, $value ){
            return new CBCountryListAfter($form, $field, implode('',$value));
        }
        
        function getCountries($lang, $name, $selected, $extra = '', $style = '', $countries_included = array(), $required = false){
            
            jimport('joomla.filesystem.file');
            
            if(JFile::exists(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins' . DS . 'country_list' . DS . $lang.'.php')){
                
                require_once(JPATH_SITE . DS . 'media' . DS . 'contentbuilder' . DS . 'plugins' . DS . 'country_list' . DS . $lang.'.php'); 
            
            }else{
                
                jimport('joomla.version');
                $version = new JVersion();
                
                if (version_compare($version->getShortVersion(), '1.6', '>=')) {
                    require_once(JPATH_SITE . DS . 'plugins' . DS . 'contentbuilder_form_elements' . DS . 'country_list' . DS . 'contentbuilder_country_list_languages' . DS . 'en-EN.php'); 
                }else{
                    require_once(JPATH_SITE . DS . 'plugins' . DS . 'contentbuilder_form_elements' . DS . 'contentbuilder_country_list_languages' . DS . 'en-EN.php'); 
                }
                
                if(function_exists('contentbuilder_countries_list')){
                    return contentbuilder_countries_list($name, $selected, $extra, $style, $countries_included, $required);
                }
            }
            
            return '';
        }
}
